-- require --

o_e = require "ogge_e"

require "player"
require "fullscreen"

love.graphics.setDefaultFilter("nearest", "nearest")

map = {
    1,1,1,0,0,0,1,1,1,
    1,0,0,0,0,0,0,0,1,
    1,0,0,0,0,0,0,0,1,
    0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,
    1,0,0,0,0,0,0,0,1,
    1,0,0,0,0,0,0,0,1,
    1,1,1,0,0,0,1,1,1,
}

floor = {
    2,2,2,2,2,2,2,2,2,
    2,2,2,2,2,2,2,2,2,
    2,2,2,2,2,2,2,2,2,
    2,2,2,2,2,2,2,2,2,
    2,2,2,2,2,2,2,2,2,
    2,2,2,2,2,2,2,2,2,
    2,2,2,2,2,2,2,2,2,
    2,2,2,2,2,2,2,2,2,
    2,2,2,2,2,2,2,2,2,
}

ceil = {
    0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,
    0,0,0,0,1,0,0,0,0,
    0,0,0,1,1,1,0,0,0,
    0,0,0,0,1,0,0,0,0,
    0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,
}

function love.load()
    for i,v in pairs(love.filesystem.getDirectoryItems("assets/cube")) do
        o_e.texture.load_texture("assets/cube/"..v,i)
    end

    love.graphics.setBackgroundColor(66/255, 151/255, 1)

    o_e.sprite.create(64*4 + 32,64*4 + 32,0,love.graphics.newImage("assets/sprites/barrel.png"),1)
    o_e.map.create(9,9)
    o_e.map.set_wall_array(map)
    o_e.map.set_floor_array(floor)
    o_e.map.set_ceil_array(ceil)
    o_e.setup()
    love.mouse.setRelativeMode(true)
end

function love.keypressed(key)
    if key == "f11" then
        do_fullscreen()
    end
end

function love.update()
    dt = love.timer.getDelta()
    move_plr()
end 

function love.draw()
    o_e.draw.world()
end 