local function setup_camera(fov, dir, position)
    oggee.camera.fov = fov
    oggee.camera.dir = dir
    oggee.camera.pdist = math.tan(math.rad((180-fov)/2)) * (oggee.screen.w/2)
    oggee.camera.x, oggee.camera.y, oggee.camera.z = unpack(position)
end

local function set_fov(fov) -- in degrees
    oggee.camera.fov = fov
    oggee.camera.pdist = math.tan(math.rad((180-oggee.camera.fov)/2)) * (oggee.screen.w/2)
    oggee.shader.update_all_floor_ceil_values()
end

local function set_position(x, y, z)
    oggee.camera.x = x
    oggee.camera.y = y
    oggee.camera.z = z
end

local function set_direction(dir) -- in radiens
    oggee.camera.dir = dir
end

local function get_direction(dir)
    return oggee.camera.dir
end

local function change_direction(dx)
    oggee.camera.dir = oggee.camera.dir + dx
end


local function get_fov(dx)
    return oggee.camera.fov
end

local camera = {
    x = 0,
    y = 0,
    z = 0,
    fov = 0,
    dir = 0,
    pdist = 0,
    dir = 0,
    setup_camera = setup_camera,
    setPosition = set_position,
    changeDirection = change_direction,
    setFov = set_fov,
    setDirection = set_direction,
    getDirection = get_direction,
    getFov = get_fov
}

return camera