function dda(startx, starty, angle, cell, map_size_x, map_size_y, map_table, maxLength)
    if maxLength == nil then
        maxLength = 100
    end
    
    local vRayStart = {
        x = startx / cell,
        y = starty / cell
    }

    local vRayDir = {
        x = math.cos(angle),
        y = math.sin(angle)
    }

    local vRayUnitStepSize = { 
        x = math.sqrt(1 + (vRayDir.y / vRayDir.x) * (vRayDir.y / vRayDir.x)),
        y = math.sqrt(1 + (vRayDir.x / vRayDir.y) * (vRayDir.x / vRayDir.y)) 
    }
	local vMapCheck = {
        x = math.floor(vRayStart.x),
        y = math.floor(vRayStart.y)
    }
	local vRayLength1D = {}
	local vStep = {}

    if vRayDir.x < 0 then
		vStep.x = -1
		vRayLength1D.x = (vRayStart.x - vMapCheck.x) * vRayUnitStepSize.x
	else
		vStep.x = 1
		vRayLength1D.x = (vMapCheck.x + 1 - vRayStart.x) * vRayUnitStepSize.x
    end

	if vRayDir.y < 0 then
		vStep.y = -1
		vRayLength1D.y = (vRayStart.y - vMapCheck.y) * vRayUnitStepSize.y
	else
		vStep.y = 1
		vRayLength1D.y = (vMapCheck.y + 1 - vRayStart.y) * vRayUnitStepSize.y
    end

    local bTileFound = false
    local fMaxDistance = maxLength
    local fDistance = 0.0

    local ver = false
    local tile

    while not bTileFound and fDistance < fMaxDistance do
		if (vRayLength1D.x < vRayLength1D.y) then
            ver = false
			vMapCheck.x = vMapCheck.x + vStep.x
			fDistance = vRayLength1D.x
			vRayLength1D.x = vRayLength1D.x + vRayUnitStepSize.x
		else
            ver = true
			vMapCheck.y = vMapCheck.y + vStep.y
			fDistance = vRayLength1D.y
			vRayLength1D.y = vRayLength1D.y + vRayUnitStepSize.y
        end

		if vMapCheck.x >= 0 and vMapCheck.x < map_size_x and vMapCheck.y >= 0 and vMapCheck.y < map_size_y then
			if map_table[vMapCheck.y * map_size_x + vMapCheck.x+1] >= 1 then
				bTileFound = true
                tile = map_table[vMapCheck.y * map_size_x + vMapCheck.x+1]
            end
        end
    end

    vIntersection = {}

    if bTileFound then
        vIntersection.x = vRayStart.x + vRayDir.x * fDistance;
        vIntersection.y = vRayStart.y + vRayDir.y * fDistance;
    end

    if bTileFound then
        return fDistance * cell, (vRayStart.x + vRayDir.x * fDistance) * cell, (vRayStart.y + vRayDir.y * fDistance) * cell, ver, tile
    else
        return false
    end
end

return dda