local wall = {}
local floor = {}
local ceil = {}

local function create_map(w,h)
    oggee.map.size.w = w
    oggee.map.size.h = h
    for x=0, w - 1 do
        for y=0, h - 1 do
            local id = y * w + x + 1
            wall[id] = 0
            floor[id] = 0
            ceil[id] = 0
        end
    end
    oggee.map.wall = wall
    oggee.map.floor = floor
    oggee.map.ceil = ceil
end

local function get_size()
    return oggee.map.size.w, map.size.h
end

local function set_floor_array(array)
     oggee.map.floor = array
end

local function set_ceil_array(array)
     oggee.map.ceil = array
end

local function set_wall_array(array)
     oggee.map.wall = array
end

local function set_floor(x, y, id, height)
    local _id = y * map.size.w + x + 1
    oggee.map.floor[_id] = id
end

local function set_ceil(x, y, id, height)
    local _id = y * map.size.w + x + 1
    oggee.map.floor[_id] = id
end

local function set_wall(x, y, id, height)
    local _id = y * map.size.w + x + 1
    oggee.map.wall[_id] = id
end

local function change_cube_size(size)
    oggee.map.cube_size = size
end 

map = {
    create = create_map,
    get_size = get_size,
    set_floor = set_floor,
    set_ceil = set_ceil,
    set_wall = set_wall,
    set_floor_array = set_floor_array,
    set_ceil_array = set_ceil_array,
    set_wall_array = set_wall_array,
    cube_size = 64,
    size = {
        w = 0,
        h = 0
    },
    wall = {},
    floor = {},
    ceil = {},
}

return map