local function update_floor()
    oggee.texture.floor_img = love.graphics.newImage(oggee.floor_data)
end

local function update_ceil()
    oggee.texture.ceil_data = love.graphics.newImage(oggee.ceil_data)
end

local function make_texture()
    floor_data = love.image.newImageData(oggee.map.size.w * oggee.map.cube_size, oggee.map.size.h * oggee.map.cube_size)
    ceil_data = love.image.newImageData(oggee.map.size.w * oggee.map.cube_size, oggee.map.size.h * oggee.map.cube_size)
    local floor = oggee.map.floor
    local ceil = oggee.map.ceil
    for x=0, oggee.map.size.w - 1 do
        for y=0, oggee.map.size.h - 1 do
            local id = y * oggee.map.size.w + x + 1
            if floor[id] > 0 then
                local texture = oggee.texture.textures[floor[id]][2]
                floor_data:paste(texture, x * oggee.map.cube_size, y * oggee.map.cube_size, 0,0, 64, 64)
            end
            if ceil[id] > 0 then
                local texture = oggee.texture.textures[ceil[id]][2]
                ceil_data:paste(texture, x * oggee.map.cube_size, y * oggee.map.cube_size, 0,0, 64, 64)
            end
        end
    end
    oggee.texture.floor_data = floor_data
    oggee.texture.ceil_data = ceil_data

    oggee.texture.floor_img = love.graphics.newImage(floor_data)
    oggee.texture.ceil_img = love.graphics.newImage(ceil_data)
end

local function load_texture(path, i)
    oggee.texture.textures[i] = {love.graphics.newImage(path), love.image.newImageData(path)}
end

local texture = {
    textures = {},
    floor_img = nil,
    ceil_img = nil,
    floor_data = nil,
    ceil_data = nil,
    load_texture = load_texture,
    make_texture = make_texture
}

return texture